﻿' Algoritmusok és lekérdezések
' LINQ példák

' Az űrlapra helyezzük el a Label1-Label5 címkéket.
' A projektbe vegyük fel a Struktúra.vb modult.

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim I As Integer

        Feltölt()

        ' A FROM záradék, A lekérdezés eredménye
        Label1.Text = ""
        Dim Tanulók = From Diák In Diákok
        For I = 0 To Tanulók.Count - 1
            Label1.Text &= Tanulók(I).Név & vbNewLine
        Next

        ' A lekérdezés végrehajtása
        Dim DiákokSzáma = (From diák In Diákok).Count
        Label2.Text = "A diákok száma: " & DiákokSzáma & vbNewLine
        Label2.Text &= "Az első négy tanuló neve:" & vbNewLine
        Kiír(Tanulók)
        Diákok(1).Név = "Kiss István"
        Label2.Text &= "A nevek a módosítás után:" & vbNewLine
        Kiír(Tanulók)

        ' Feltételek a lekérdezésben
        Tanulók = From Diák In Diákok _
                       Where Diák.Fiú = True And _
                             Diák.Név.Substring(1, 1) = "a" And _
                             (Diák.Magasság < 150 Or Diák.Magasság > 170)
        KiírÖsszes(Tanulók, Label3)

        ' A lekérdezés rendezése
        Tanulók = From Diák In Diákok _
                       Order By Diák.Fiú Descending, Diák.Név
        KiírÖsszes(Tanulók, Label4)

        ' A mezők kiválasztása
        Dim BMIIndexek = From Diák In Diákok _
                Select BMI = Diák.Tömeg / (Diák.Magasság / 100) ^ 2 _
                Order By BMI
        Label4.Text = ""
        For I = 0 To BMIIndexek.Count - 1
            Label4.Text &= BMIIndexek(I).ToString("F2") & vbNewLine
        Next

        ' Összesítő lekérdezések
        Dim Összesít = Aggregate Diák In Diákok _
                 Into Magasság = Sum(Diák.Magasság), _
                      Szám = Count(Diák.Magasság)
        Label5.Text = "Átlagos magasság: "
        Label5.Text &= Összesít.Magasság / Összesít.Szám & vbNewLine

        Dim Legmagasabb = From Diák In Diákok _
                               Where Diák.Magasság = _
                                    (Aggregate Egyed In Diákok _
                                               Into Max(Egyed.Magasság)) _
                               Select Név = Diák.Név, Magasság = Diák.Magasság
        Label5.Text &= vbNewLine & "Legmagasabbak:" & vbNewLine
        For Each Elem In Legmagasabb
            Label5.Text &= Elem.Név & " (" & Elem.Magasság & " cm)" & vbNewLine
        Next

    End Sub

    Sub Kiír(ByVal Lista As IEnumerable(Of TDiák))
        Dim I As Integer
        For I = 0 To 3
            Label2.Text &= Lista(I).Név & vbNewLine
        Next
        Label2.Text &= vbNewLine
    End Sub

    Sub KiírÖsszes(ByVal Lista As IEnumerable(Of TDiák), ByVal Címke As Label)
        Címke.Text = ""
        For Each Elem In Lista
            Címke.Text &= Elem.Név & vbNewLine
        Next
    End Sub

End Class
